Loading...
Searching...
No Matches
L4Re::Event Class Reference
L4Re C++ Interface » Event API

Event class. More...

`#include <event>`

Inheritance diagram for L4Re::Event:
Collaboration diagram for L4Re::Event:

## Public Member Functions

long | get_buffer (L4::Ipc::Out< L4::Cap< Dataspace > > ds)
| Get event signal buffer.
long | get_num_streams ()
| Get number of event streams.
long | get_stream_info (int idx, Event_stream_info *info)
| Get event stream infos.
long | get_stream_info_for_id (l4_umword_t stream_id, Event_stream_info *info)
| Get event stream infos.
long | get_axis_info (l4_umword_t stream_id, unsigned naxes, unsigned const *axis, Event_absinfo *info) const noexcept
| Get event stream axis infos.
long | get_stream_state_for_id (l4_umword_t stream_id, Event_stream_state *state)
| Get event stream state.
Public Member Functions inherited from L4::Icu
l4_msgtag_t | bind (unsigned irqnum, L4::Cap< Triggerable > irq, l4_utcb_t *utcb=l4_utcb()) noexcept
| Bind an interrupt line of an interrupt controller to an interrupt object.
l4_msgtag_t | unbind (unsigned irqnum, L4::Cap< Triggerable > irq, l4_utcb_t *utcb=l4_utcb()) noexcept
| Remove binding of an interrupt line from the interrupt controller object.
l4_msgtag_t | info (l4_icu_info_t *info, l4_utcb_t *utcb=l4_utcb()) noexcept
| Get information about the ICU features.
l4_msgtag_t | msi_info (l4_umword_t irqnum, l4_uint64_t source, l4_icu_msi_info_t *msi_info)
| Get MSI info about IRQ.
l4_msgtag_t | mask (unsigned irqnum, l4_umword_t *label=0, l4_timeout_t to=L4_IPC_NEVER, l4_utcb_t *utcb=l4_utcb()) noexcept
| Mask an IRQ line.
l4_msgtag_t | set_mode (unsigned irqnum, l4_umword_t mode, l4_utcb_t *utcb=l4_utcb()) noexcept
| Set interrupt mode.
Public Member Functions inherited from L4::Irq_eoi
l4_msgtag_t | unmask (unsigned irqnum, l4_umword_t *label=0, l4_timeout_t to=L4_IPC_NEVER, l4_utcb_t *utcb=l4_utcb()) noexcept
| Unmask the given interrupt line.

## Additional Inherited Members

Protected Types inherited from L4::Kobject_t< Event, L4::Icu, L4RE_PROTO_EVENT >
typedef Event | Class
| The target interface type (inheriting from Kobject_t).
typedef Typeid::Iface< PROTO, Event > | __Iface
| The interface description for the derived class.
typedef Typeid::Merge_list< Typeid::Iface_list< __Iface >, typename L4::Icu::__Iface_list > | __Iface_list
| The list of all RPC interfaces provided directly or through inheritance.
Protected Types inherited from L4::Kobject_t< Icu, Irq_eoi, L4_PROTO_IRQ, Type_info::Demand_t< 1 > >
typedef Icu | Class
| The target interface type (inheriting from Kobject_t).
typedef Typeid::Iface< PROTO, Icu > | __Iface
| The interface description for the derived class.
typedef Typeid::Merge_list< Typeid::Iface_list< __Iface >, typename Irq_eoi::__Iface_list > | __Iface_list
| The list of all RPC interfaces provided directly or through inheritance.
Protected Member Functions inherited from L4::Kobject_t< Event, L4::Icu, L4RE_PROTO_EVENT >
L4::Cap< Class > | c () const noexcept
| Get the capability to ourselves.
Protected Member Functions inherited from L4::Kobject_t< Icu, Irq_eoi, L4_PROTO_IRQ, Type_info::Demand_t< 1 > >
L4::Cap< Class > | c () const noexcept
| Get the capability to ourselves.
Static Protected Member Functions inherited from L4::Kobject_t< Event, L4::Icu, L4RE_PROTO_EVENT >
static void | __check_protocols__ () noexcept
| Helper to check for protocol conflicts.
Static Protected Member Functions inherited from L4::Kobject_t< Icu, Irq_eoi, L4_PROTO_IRQ, Type_info::Demand_t< 1 > >
static void | __check_protocols__ () noexcept
| Helper to check for protocol conflicts.

## Detailed Description

Event class.

See also
  L4Re Event API

Definition at line 137 of file event.

## Member Function Documentation

## get_axis_info()

long L4Re::Event::get_axis_info | ( | l4_umword_t | stream_id,
|  | unsigned | naxes,
|  | unsigned const * | axis,
|  | Event_absinfo * | info ) const

inlinenoexcept

Get event stream axis infos.

Parameters

  | stream_id | ID of the event stream.
  [in] | naxes | Number of axis IDs and axis infos.
  [in] | axis | Array of axis IDs.
  [out] | info | Array of axis infos.

Return values

  >=0 | Number of returned axes infos.
  <0 | Error code.

Definition at line 198 of file event.

References L4::Kobject_t< Event, L4::Icu, L4RE_PROTO_EVENT >::c(), and L4::Icu::info().

Referenced by get_stream_info_for_id().

Here is the call graph for this function:
Here is the caller graph for this function:

## get_buffer()

long L4Re::Event::get_buffer | ( | L4::Ipc::Out< L4::Cap< Dataspace > > | ds | ) |

Get event signal buffer.

Parameters

  [out] | ds | Event buffer.

Return values

  0 | Success
  <0 | Error

References get_buffer().

Referenced by get_buffer().

Here is the call graph for this function:
Here is the caller graph for this function:

## get_num_streams()

long L4Re::Event::get_num_streams | ( |  | ) |

Get number of event streams.

Return values

  >=0 | Number of streams.
  <0 | Error code.

References get_num_streams().

Referenced by get_num_streams().

Here is the call graph for this function:
Here is the caller graph for this function:

## get_stream_info()

long L4Re::Event::get_stream_info | ( | int | idx,
|  | Event_stream_info * | info )

Get event stream infos.

Deprecated. Use get_stream_info_for_id().

Parameters

  | idx | ID of the event stream.
  [out] | info | Event stream info.

Return values

  0 | Success
  <0 | Error

References get_stream_info(), and L4::Icu::info().

Referenced by get_stream_info().

Here is the call graph for this function:
Here is the caller graph for this function:

## get_stream_info_for_id()

long L4Re::Event::get_stream_info_for_id | ( | l4_umword_t | stream_id,
|  | Event_stream_info * | info )

Get event stream infos.

Parameters

  | stream_id | ID of the event stream.
  [out] | info | Event stream info.

Return values

  0 | Success
  <0 | Error

References get_axis_info(), get_stream_info_for_id(), and L4::Icu::info().

Referenced by get_stream_info_for_id().

Here is the call graph for this function:
Here is the caller graph for this function:

## get_stream_state_for_id()

long L4Re::Event::get_stream_state_for_id | ( | l4_umword_t | stream_id,
|  | Event_stream_state * | state )

Get event stream state.

Parameters

  | stream_id | ID of the event stream.
  [out] | state | Event stream state.

Return values

  0 | Success
  <0 | Error

The documentation for this class was generated from the following file:

- l4/re/event